// Thomas Grenier - Creatis

// Loi gamma
shape = 5;
scale = 1;
Xi = grand( 100, 1, 'gam', shape, scale); 
[dimX dimY] = size(Xi);

// Estimation en position x,y , pour tout r
res_F = 100;

var_x = linspace( 0, 20, res_F);
F = ones( res_F, 1);

for i=1:res_F,
  F(i) = KPlusProchesVoisins( var_x(i), Xi, 10);
end;


scf();	
histplot(30, Xi);//, style=2)
plot( Xi, 0.02.*ones(dimX, dimY), 'b+')

scf();
deff('[z]=poisson(x)','z=(scale^shape)*x^(shape-1)*exp(-scale*x)/gamma(shape)' );
//plot(px, feval(px,poisson),'b' )
//plot( Xi, 0.02.*ones(dimX, dimY), 'b+')
plot(var_x, F,'r', var_x, feval(var_x,poisson),'b' );


