// Thomas Grenier - Creatis

// Cluster -> filtrage fukunaga
// exec('C:\Users\grenier\Documents\Grenier\Scilab\DParzen_G.sci', -1)
// exec('C:\Users\grenier\Documents\Grenier\Scilab\PlotImage.sci', -1)

h= [3 3 30];
nb_Xi = 360 ;
nb_it = 25;

PlotImage( ima );
title('GBMS');
hdl_fig = gcf();
CM_Size = size(hdl_fig.color_map);
hdl_fig.color_map = [ hdl_fig.color_map; 
    0. 0. 1.; 
    0. 1 0.;
    1. 0. 0.;
    0. 1 1;
    1 0. 1;
    1 1 0];
x=1:6;
color_map=CM_Size(1)+x;


f_ima = ima;

// Shoot Xi  qui s'appellent Y ...
[nb_X, nb_Y]= size(ima);

// Exemple 1
//Y=[grand( nb_Xi/2 , 'mn', [23;30] , [20 0 ;0 20] )',ones(nb_Xi/2,1); grand( nb_Xi/2 , 'mn', [37; 30] , [20 0 ;0 20] )', ones(nb_Xi/2,1)];

// Exemple 2
//Ya=[grand( nb_Xi/3 , 'mn', [20;30] , [20 0 ;0 20] )',ones(nb_Xi/3,1)];
//Yb=[grand( nb_Xi/3 , 'mn', [40; 30] , [20 0 ;0 20] )', ones(nb_Xi/3,1)];
//Yc=[grand( nb_Xi/3 , 'mn', [30; 40] , [15 0 ;0 15] )', ones(nb_Xi/3,1)];
//plot(Ya(:,1) , Ya(:,2), 'r+');
//plot(Yb(:,1) , Yb(:,2), 'bx');
//plot(Yc(:,1) , Yc(:,2), 'g*');
//Y=[Ya; Yb; Yc];

// Exemple 3
Y=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y ), ones(nb_Xi,1)];
plot(Y(:,1) , Y(:,2), '+');

// all cases
for i=1:nb_Xi,
  Y(i,3)= ima( Y(i,1), Y(i,2) );
end

// Sauvegarde des Y
sY = Y;

// Estimation du deplacement en position x,y
Yn = Y;
for i=1:nb_it,
  for j=1:nb_Xi,
    Yn(j,:) = DParzen_G(Y(j,:), Y, h);
  end;
  xarrows([Y(:,1)';Yn(:,1)'], [Y(:,2)';Yn(:,2)'], 1, color_map(modulo(i-1,size(color_map,2))+1)); 
  Y = Yn;
end;  

plot(Y(:,1), Y(:,2), 'w*' );

