// Thomas Grenier - Creatis

// Gaussian Non Blurring Mean Shift

h= [3 3 3];
nb_Xi = 210;
max_it = 15;
max_epsilon = 0.2;

PlotImage( ima );
title('GMS');
f_ima = ima;

// Shoot Xi  
[nb_X, nb_Y]= size(ima);
//Xi=[grand( nb_Xi/2 , 'mn', [23;30] , [20 0 ;0 20] )',ones(nb_Xi/2,1); grand( nb_Xi/2 , 'mn', [37; 30] , [20 0 ;0 20] )', ones(nb_Xi/2,1)];
//Xi=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y ), ones(nb_Xi,1)];
//for i=1:nb_Xi,
//  Xi(i,3)= ima( Xi(i,1), Xi(i,2) );
//end
//plot(Xi(:,1) , Xi(:,2), '+');

Ya=[grand( nb_Xi/3 , 'mn', [20;30] , [20 0 ;0 20] )',ones(nb_Xi/3,1)];
Yb=[grand( nb_Xi/3 , 'mn', [40; 30] , [20 0 ;0 20] )', ones(nb_Xi/3,1)];
Yc=[grand( nb_Xi/3 , 'mn', [30; 40] , [15 0 ;0 15] )', ones(nb_Xi/3,1)];
Y=[Ya; Yb; Yc];
//Y=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y ), ones(nb_Xi,1)];
for i=1:nb_Xi,
  Y(i,3)= ima( Y(i,1), Y(i,2) );
end

plot(Ya(:,1) , Ya(:,2), 'r+');
plot(Yb(:,1) , Yb(:,2), 'bx');
plot(Yc(:,1) , Yc(:,2), 'g*');

// PlotImage( ima );
title('GMS');
Xi=Y;
//plot(Xi(:,1) , Xi(:,2), '+');

// Estimation du deplacement en position x,y
color_map=['r' 'g' 'c' 'm' 'w' 'k'];
//Y  = Xi;
Yn = Y;
i  = 1;
Xi_conv = 0;
not_conv = 1;
epsilon = 10*ones(nb_Xi,1);
while (i<max_it) & not_conv,
  disp('Iter :' + string(i) + ' eps = ' + string(mean(epsilon)) + ' Xi_conv:' + string(Xi_conv) );
  not_conv=0;
  Xi_conv = 0;
  for j=1:nb_Xi,
    if epsilon(j) > max_epsilon,
      Yn(j,:) = DParzen_G(Y(j,:), Xi, h);
      epsilon(j) = norm(Yn(j,:) - Y(j,:) );  
      not_conv=1;
      plot([Y(j,1) Yn(j,1)], [Y(j,2) Yn(j,2)], color_map(modulo(i-1,size(color_map,2))+1))
    else
      Xi_conv = Xi_conv + 1;
    end;
  end;
 
  for j=1:nb_Xi,
   
  end;
  
  Y = Yn;
  i=i+1;
end;  
disp('*** End : eps = ' + string(mean(epsilon)) + ' Xi_conv:' + string(Xi_conv) );

plot(Y(:,1), Y(:,2), 'w*' );

//
//for i=1:nb_X,
//  disp('Ligne :' + string(i));
//  for j=1:nb_Y,
//    //a = ProcedureMeanShift( [i,j, ima(i,j)] , Y, 2*h, 0.2);
//    a=Parzen_G( [i,j, ima(i,j)], Y, h);
//    f_ima(i,j) = a;
//  end;
//end;
//PlotImage(f_ima);

