// Thomas Grenier - Creatis

res = 1000;
h=7;
n=5;
x=linspace(1,100,res);

sg(1)=30;
sg(2)=45;
sg(3)=50;
sg(4)=60;
sg(5)=80;

scf();
plot( sg([1:n]), 0.01,'b+');

// Profil Gaussien
function [y]=k_gauss(x)
y = exp(-x/2) / sqrt(2*3.1415);
endfunction

profil = zeros(n,res);
estimation = zeros(1,res);


for j=1:n,
  for i=1:res,
    a = (x(i)-sg(j)) * (x(i)-sg(j)) / (h*h);
    profil(j,i) = k_gauss( a );
    estimation(1,i) = estimation(1,i) + k_gauss( a );
  end;
plot(x,profil(j,:)./(n*h), 'k');  
end;


plot(x,estimation(1,:)./(n*h), 'r');  

