// Thomas Grenier - Creatis

function [h]=EstimationH_Gauss(Y)

h=[0 0 0];
[nb_Y, tmp]= size(Y);
alphaS = (1/nb_Y)^(1/6);
alphaR = (4/(3*nb_Y))^(1/5);
h(1) = alphaS * iqr(Y(:,1),'r')./1.349;  
h(2) = alphaS * iqr(Y(:,2),'r')./1.349; 
h(3) = alphaR * iqr(Y(:,3),'r')./1.349; 

endfunction
