// Thomas Grenier - Creatis

// Image : ima

// h= [10 10 10];
[nb_X, nb_Y]= size(ima);
nb_Xi =  nb_X * nb_Y / 10;

ligne = 30;

PlotImage(ima);

// Shoot Xi  qui s'appellent Y ...

Y=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y ), ones(nb_Xi,1)];
plot(Y(:,1) , Y(:,2), '+');
for i=1:nb_Xi,
  Y(i,3)= ima( Y(i,1), Y(i,2) );
end

//determination de h
h=EstimationH_Gauss(Y)

// Estimation en position x,y , pour tout r
res_F_R = 50;
res_var_x = 5;
color_map=['r' 'g' 'k' 'c' 'm' 'b' 'k' 'r' 'g' 'k' 'c' 'm' 'b' 'k'];
r = linspace(min(ima), max(ima), res_F_R);
var_x = linspace( 10, 50, res_var_x);
F_R = ones( res_var_x+1, res_F_R);
for j=1:res_var_x,
  for i=1:res_F_R,
    F_R(j,i) = Parzen_G( [var_x(j) ligne r(i)], Y, h);
  end;
  plot( var_x(j), ligne, 'o'+color_map(j) );
end;

 // for i=1:res_F_R,
 //   F_R(res_var_x+1,i) = Parzen( [1 1 r(i)], Y, [1000 1000 h(3)]);
 // end;


scf();	
//histplot(30, Y(:,3));//, style=2)
for j=1:res_var_x,
  plot( r, F_R(j,:), color_map(j));
  plot( ima( var_x(j),ligne), Parzen_G( [var_x(j) ligne ima( var_x(j), ligne)], Y, h) , color_map(j)+'o');  
end;


