// Thomas Grenier - Creatis


//ima = GenerateurImage(10);


function [y]=k_gauss_1D(x)
  y = exp(-x/2) / sqrt(2*3.14159);
endfunction


function [fx]=Parzen_1D(X,Xi,h)
fx=0;
[nb_Xi,dim]=size(Xi);
for i = 1:nb_Xi,
  x_xi = X  - Xi(i);
  dxr = x_xi / h;
  fx = fx + k_gauss_1D( dxr * dxr );
end
fx = fx / (nb_Xi * h );
endfunction


//chemin = 'C:\Users\Thomas\Doc\Creatis\These\Scilab\';
//exec(chemin+'Ex_ClusterFiltrageMS.sce');

for i=1:size(Y,1),
  d_y(i)=Dist2Mahalanobis(Y(1,:),Y(i,:),[10 10 10]);
end;


res_F = 400;
F = ones( res_F, 1);
px=linspace( 0, max(d_y), res_F);

for i=1:res_F,
  F(i) = Parzen_1D( px(i), d_y, 0.01);
end;

figure;
plot(px,F);




