// Thomas Grenier - Creatis

// Cluster -> filtrage fukunaga
ima =  GenerateurImage( 20) ;
// decommenter pour image couleur
//PathToScript    = 'E:\Creatis\Creatis_CVS\Grenier\Scilab\';
//ima_RGB = imread( PathToScript + 'Resultats\lena_Couleur.bmp');
//ima = rgb2gray(ima_RGB);
//ima = double(ima(512/2 - 128/2:512/2 + 128/2, 512/2 - 128/2:512/2 + 128/2));
//// //ima = ima(1:128, 1:128);
//// //ima = double(ima(1:256, 1:256));

PlotImage( ima);

h= [5 5 10];
nb_Xi = 300 ;
nb_it = 15;

title('GBMS');
f_ima = ima;

// Shoot Xi  qui s'appellent Y ...
[nb_X, nb_Y]= size(ima);
Y=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y ), ones(nb_Xi,1)];
for i=1:nb_Xi,
  Y(i,3)= ima( Y(i,1), Y(i,2) );
end

plot(Y(:,1) , Y(:,2), 'b+');
title('GBMS');

// Sauvegarde des Y
sY = Y;

// Estimation du deplacement en position x,y
color_map=['r' 'g' 'c' 'm' 'w' 'k'];
Yn = Y;
for i=1:nb_it,

  for j=1:nb_Xi,
    Yn(j,:) = DParzen_Gc(Y(j,:), Y, h);
  end;

  for j=1:nb_Xi,
    plot([Y(j,1) Yn(j,1)], [Y(j,2) Yn(j,2)], color_map(modulo(i-1,size(color_map,2))+1))
  end;
  Y = Yn;
  disp('It :'+string(i));
end;  

plot(Y(:,1), Y(:,2), 'w*' );

//for i=1:nb_X,
//  disp('Ligne :'+string(i));
//  for j=1:nb_Y,
//    //a = ProcedureMeanShift( [i,j, ima(i,j)] , Y, 2*h, 0.2);
//    a=Parzen_G( [i,j, ima(i,j)], Y, h);
//    f_ima(i,j) = a;
//  end;
//end;
//PlotImage(f_ima);
